#include <stdio.h>
#include <math.h>
#define BYTE  unsigned char
int wlen=2200;                    // cut_pic width
int hlen=3200;                    // cut_pic height

#define maxn  3600*5100           // max pic size,iW*iH
BYTE b[maxn];                     // raw & result map
BYTE a[maxn];                     // temporary work map
int  iW,iH,iColorType;            // width, height, 256/16m_color
short h[539];                     // BMP header
double a1,a2,a3,a4,a5,a6;         // 6 transfer parms
int  it;                          // print more

double angle;                     // given or calculate: cut_pic turn around
int  xc,yc;                       // given or calculate: cut_pic center pixel

int  bmp2raw(char *f1,BYTE *b);
void rot(BYTE *b,int iW,int iH,double angle);
void get_angle_xyc(BYTE *b,int iW,int iH,double *angle,int *xc,int *yc);
void cut(BYTE *b,int *iW,int *iH,int xc,int yc);
void raw2bmp(char *f2,BYTE *b);
void my_parb(int *aa,int nn,double *bb,int mm);

main(int ac,char **av)
{
  char f1[22],f2[24]; int i,u,v; double z;
  if(ac<2){ printf("\n\t ****** cut of BMP(256) *******\n");
            printf("\n\t                       jiang, 2013,12,04\n");
            printf("\n\t sl21 in[.bmp] [angle xc yc !]");
            printf("\n\t Usage: sl11 page1 -1.2");
            printf("\n\t set output bmp file:  s_in.bmp  %d*%d",wlen,hlen);
            printf("\n\t angle: in degree");
            printf("\n\t xc yc: cut_pic center");
            printf("\n\t ! means: print more\n\n");
            return(0); }
  if(av[1][0]=='!'){
            printf("\n\t sl21 p1 0.5 1000 2200");
            printf("\n\t sl21 p2 1.2 1000 2200");
            printf("\n\t sl21 p3 0.0 1000 2150");
            printf("\n\t sl21 p4 2.0 1000 2150");
            printf("\n\t sl21 p5 -1. 1000 2150");
            printf("\n\t sl21 page0 -2.3 1600 2150");
            printf("\n\t sl21 page1 -1.5 1000 3100");
            printf("\n\t sl21 page2 -1.0 1000 2950");
            printf("\n\t sl21 page3 -1.5 1100 2950");
            printf("\n\t sl21 page4  1.5 1000 2950");
            printf("\n\t sl21 page5  2.8 1500 2700");
            printf("\n\t sl21 page6  2.0 1180 1750");
            printf("\n\t sl21 page7  2.0 1150 1950");
            printf("\n\t sl21 page8  0.0 1150 3350");
            printf("\n\t sl21 page9  3.5 1580 1950");
            printf("\n"); return(0); }
  it=(ac>5)?1:0; strcpy(f1,av[1]);
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0; strcat(f1,".bmp");
  angle=99.; if(ac>2)sscanf(av[2],"%lf",&angle);
  xc=yc=-1;  if(ac>3)sscanf(av[3],"%d",&xc);
             if(ac>4)sscanf(av[4],"%d",&yc);

  i=bmp2raw(f1,b);
  if(i==1){ printf("\n\t%s not found!\n",f1); return(0); }
  if(i==2){ printf("\n\t%s color map not support !\n",f1); return(0); }
  if(iW<wlen)wlen=iW;  if(iH<hlen)hlen=iH;

  if(ac<4)get_angle_xyc(b,iW,iH,&z,&u,&v);
  if(angle==99.)angle=z;
  if(xc==-1)xc=u;
  if(yc==-1)yc=v;
  printf("%7.1lf %d %d ",angle,xc,yc);

  rot(b,iW,iH,angle);
  cut(b,iW,iH,xc,yc);

  iW=wlen; iH=hlen;
  sprintf(f2,"s_%s",f1); printf(" ok ! outfile: %s\n",f2);
  raw2bmp(f2,b);

  return(0);
}

int bmp2raw(char *f1,BYTE *b)
{
  int i,j,k; FILE *fp; BYTE *p1;
  fp=fopen(f1,"rb"); if(!fp)return(1); printf("%s ==> ",f1);
  fread(h,2,27,fp);  iColorType=h[14]/8;  iW=h[9]; iH=h[11];
  if(it)printf("iW:%6d\tiH:%6d\tcolor: %d\n",iW,iH,iColorType);
  if(iColorType==3)return(2);
  k=(4-iW%4)%4+iW; fread(&h[27],2,512,fp);
  for(j=0;j<iH;j++){ p1=(BYTE *)b+j*iW; fread(p1,1,k,fp); }
  fclose(fp);
  return(0);
}

void get_angle_xyc(BYTE *b,int iW,int iH,double *angle,int *xc,int *yc)
{
  int i,j,k,ii,jj,w2,h2,d[400],d1,d2;
  double e[4],ex,ey;
  w2=iW/2; h2=iH/2;
  k=0; for(j=h2-10;j<h2+10;j++)for(i=iW-220;i<iW-200;i++)d[k++]=b[j*iW+i];
  for(i=0;i<399;i++)for(j=i+1;j<400;j++)if(d[i]>d[j]){
    k=d[i]; d[i]=d[j]; d[j]=k;
  } d1=d[200]-9; d2=d[200]+9;

  for(ii=0,j=h2-200;j<h2+200;j++,ii++){ d[ii]=0;
    k=0;  jj=j*iW;
    for(i=w2;i<iW;i++)if(b[jj+i]<d1 || b[jj+i]>d2)k=0; else {
      k++; if(k>9)break; }
    d[ii]=i;
  }
  my_parb(d,400,e,2);
  *xc=e[0]+200*e[1]-1100;
  ex=-atan(e[1])*180./3.1416;

  for(ii=0,i=w2-400;i<w2;i++,ii++){ d[ii]=0;
    k=0;
    for(j=h2;j<iH;j++)if(b[j*iW+i]<d1 || b[j*iW+i]>d2)k=0; else {
      k++; if(k>9)break; }
    d[ii]=j;
  }
  my_parb(d,400,e,2);
  *yc=e[0]+400*e[1]-1600;
  ey=atan(e[1])*180./3.1416;

  *angle=(ex+ey)/2;
}

void rot(BYTE *b,int iW,int iH,double angle)
{
  int i,j,k, ix,iy,u,v;
  double cosa,sina,z;
  float x,y, wx,wy,ux,uy, z0,z1,z2,z3;
  BYTE *p0,*p1;
  z=angle*3.1416/180.;
  cosa=cos(z); sina=sin(z);
  a1=a4=cosa; a2=sina;  a3=-a2; a5=iW/2; a6=iH/2;

  p0=(BYTE *)b; p1=(BYTE *)a;
  for(j=0;j<iH;j++)for(i=0;i<iW;i++){
    x=a1*(i-a5)+a3*(j-a6)+a5; y=a2*(i-a5)+a4*(j-a6)+a6;
    ix=x; wx=x-ix; ux=1.-wx; iy=y; wy=y-iy; uy=1.-wy;
    if(ix<0 || ix>=iW-2 || iy<0 || iy >=iH-2){ *p1++=255; continue; }
    u=iW*iy+ix; v=u+iW;
    if(u>=0 && v<iW*iH-1){
      z0=ux*uy; z1=wx*uy; z2=ux*wy; z3=wx*wy;
      *p1++=p0[u]*z0+p0[u+1]*z1+p0[v]*z2+p0[v+1]*z3;
    } else *p1++=255;
  }
  p0=(BYTE *)b; p1=(BYTE *)a; for(i=0;i<iW*iH;i++)*p0++=*p1++;
}

void cut(char *b,int iW,int iH,int xc,int yc)
{
  int i,j,i1,i2,j1,j2; BYTE *p0,*p1;
  p0=(BYTE *)b; p1=(BYTE *)a; for(i=0;i<iW*iH;i++)*p1++=*p0++;  // may ignore
  i1=xc-wlen/2; i2=xc+wlen/2;
  if(i1<0){ i2-=i1;  i1=0; } if(i2>=iW){ i1-=i2-iW; i2=iW; }
  j1=yc-hlen/2; j2=yc+hlen/2;
  if(j1<0){ j2-=j1;  j1=0; } if(j2>=iH){ j1-=j2-iH; j2=iH; }
  p0=(BYTE *)b; for(j=j1;j<j2;j++)for(i=i1;i<i2;i++)*p0++=a[j*iW+i];
}

void raw2bmp(char *f2,BYTE *b)
{
  int i,j,k;  FILE *fp; BYTE *p1;
  h[9]=iW; h[11]=iH;
  fp=fopen(f2,"wb"); k=(4-iW%4)%4+iW; fwrite(h,2,539,fp);
  for(j=0;j<iH;j++){ p1=(BYTE *)b+j*iW; fwrite(p1,1,k,fp); } fclose(fp);
}

tofit(f1,a,n1,n2)
char *f1; BYTE *a; int n1,n2;
{
  int i,j; FILE *fp; char head[36][80];
  for(j=0;j<36;j++)for(i=0;i<80;i++)head[j][i]=32;
  sprintf(head[ 0],"SIMPLE  =                    T /");
  sprintf(head[ 1],"BITPIX  =                    8 /");
  sprintf(head[ 2],"NAXIS   =                    2 /");
  sprintf(head[ 3],"NAXIS1  =                 %4d /",n1);
  sprintf(head[ 4],"NAXIS2  =                 %4d /",n2);
  sprintf(head[35],"END                             ");
  for(j=0;j<36;j++)head[j][32]=32;
  fp=fopen(f1,"wb");  fwrite(head,36,80,fp);
  fwrite(a,n1,n2,fp); fclose(fp);
  printf("%s produced !\n",f1);
}

void my_parb(aa,nn,bb,mm)
int *aa; double *bb; int nn,mm;
{
  int i,j,k,l; double y,x,x2,x3, mx[3][3], s[6];
  for(i=0;i<mm;i++){ bb[i]=s[i]=s[i+mm]=0.; for(j=0;j<mm;j++)mx[i][j]=0.; }
  for(i=0;i<nn;i++){ if(aa[i]==0)continue;
    y=aa[i]; x=i; x2=x*x; x3=x*x2;
    s[0]++; s[1]+=x; s[2]+=x2; s[3]+=x3; s[4]+=x2*x2;
    bb[0]+=y;  bb[1]+=y*x; bb[2]+=y*x2; bb[3]+=y*x3;
  } for(j=0;j<mm;j++)for(i=0;i<mm;i++)mx[j][i]=s[j+i];
  if(s[0]<mm){ printf(" less data!\n"); return; }
  for(i=0;i<mm-1;i++){ x=0.;
    for(k=i;k<mm;k++){ y=mx[k][i]; if(y<0.)y=-y; if(y>x){ x=y; l=k; } }
    if(x==0.){ for(k=0;i<mm;k++)bb[k]=0.; printf("Zero_MATRIX\n"); return; }
    if(i!=l){
      for(j=0;j<mm;j++){ y=mx[i][j]; mx[i][j]=mx[l][j]; mx[l][j]=y;}
      y=bb[i]; bb[i]=bb[l]; bb[l]=y;
    } x=mx[i][i];
    for(j=i+1;j<mm;j++){
      y=mx[j][i]/x; bb[j]-=y*bb[i]; for(k=i;k<mm;k++)mx[j][k]-=y*mx[i][k];
    }
  }
  for(i=0;i<mm;i++){ l=mm-1-i; if(mx[l][l]==0.){ bb[l]=0.; continue; }
    y=bb[l]; if(l!=mm-1)for(j=1;j<=i;j++){ k=mm-j; y-=mx[l][k]*bb[k]; }
    bb[l]=y/mx[l][l];
  }
}

